# Chapter 8: Creating Bitcoin Script Transactions

Bitcoin Script moves down several levels of abstraction, allowing you to minutely control the redemption conditions of Bitcoin funds. But, how do you actually incorporate those Bitcoin Scripts into the transactions you've been building to date? The answer is a new sort of Bitcoin transaction, the P2SH.

## Objectives for This Chapter

After working through this chapter, a developer will be able to:

   * Design a Bitcoin Script
   * Design a P2SH Transaction
   
Supporting objectives include the ability to:

   * Understand the P2SH Script
   * Understand the Multisig Script
   * Test a Bitcoin Script
   
## Table of Contents

* [Section One: Building a Bitcoin Script with P2SH](8_1_Building_a_Bitcoin_Script_with_P2SH.md)
* [Section Two: Scripting a Multisig](8_2_Scripting_a_Multisig.md)
* [Section Three: Testing a Bitcoin Script](8_3_Testing_a_Bitcoin_Script.md)
* [Section Four: Sending & Spending a Bitcoin Script](8_4_Send_and_Spending_a_Bitcoin_Script.md)
